/*

	Associative Lists Article:
		http://www.byond.com/members/DreamMakers?command=view_post&post=32170

	version 2:
	 * added a new example

*/

client/New()
		..()
		src<<"Welcome to the associative lists demo. For a further article by dream makers, click <A href=http://www.byond.com/members/DreamMakers?command=view_post&post=32170>here</a>.<br>For more demonstrations by me, click <A href=http://www.byond.com/developer/Cameron>here.</a><br>Please look through both examples thoroughly."

world/name="Associative Lists"


/*

pseudo-Admin List Associative List

*/

var/list/admins[0] // initialise the list

client/verb
	View_Admins()
		set category="Example 1(pseudo-Admin List)"
		if(!admins.len)src<<"There are currently no admins."
		for(var/a in admins)
			src<<"[a] - Status: [admins[a]]" // admins[a] gets their status.
		if(admins.len)src<<"[admins.len] admin\s."
	Add_Admin()
		set category="Example 1(pseudo-Admin List)"
		var/key=input("Input a key")as text|null
		if(!key)return
		var/status=input("What is [key]'s status?")as text|null
		if(!status)return
		admins[key]=status // Add them to the admin list as [status]
		src<<"You added [key] to the admin list as \an [status]."


/*

psuedo-Shop Associative List

*/

var/list/supplies=list("Apple"=10,"Pear"=15,"Necklace"=100,"Music Disc"=53)
// This list above shows items plus their price. This saves you creating a seperate variable

client/verb
	View_Supplies()
		set category="Example 2(pseudo-Shopkeeper)"
		src<<"I currently have the following:"
		for(var/i in supplies)
			src<<"[i] at the price of $[supplies[i]]" // Show the price of the item.
		src<<"See anything you would like to purchase?"
	Purchase_Supplies()
		set category="Example 2(pseudo-Shopkeeper)"
		if(!supplies.len)
			src<<"I don't have anything left to sell you!"
		else
			var/item=input("Hey there, what would you like to purchase today?")as null|anything in supplies
			if(item)
				var/confirmation=input("Are you sure you would to purchase [item] at the price of $[supplies[item]]?")as null|anything in list("Yes","No")
				if(!confirmation || confirmation=="No")return
				else
					src<<"You pay the merchant $[supplies[item]] for the [item]."
					supplies-=item
			else src<<"Please return again sometime."

/*

Lists of Lists

*/

var/list/food=list("Egg"=list("White","Yolk"),"Bacon"=list("Meat","Fat"),"Ham Burger"=list("Cucumber","Lettuce","Tomatoes"))

client/verb
	View_Menu()
		set category="Example 3(pseudo-Restaurant)"
		for(var/f in food)
			var/added = 0
			var/string = "[f] (Contains: "
			var/list/l = food[f]
			if(!istype(l)) continue
			for(var/c in l)
				if(added) string += ", [c]"
				else {string += "[c]"; added=1}
			string += ")"
			src << string
	Purchase_Food()
		set category="Example 3(pseudo-Restaurant)"
		var/foodchoice=input("Welcome to the pseudo-restaurant, what would you like to eat?")as null|anything in food
		if(!foodchoice)
			src<<"Please come again soon!"
		else
			if(alert("Would you like anything in particular to be taken out of the [foodchoice]?","Optional","Yes Please","No Thanks")=="Yes Please")
				var/taken=null
				var/list/ingredients[]
				for(var/f in food)
					ingredients+=food[foodchoice]
				while(1)
					if(!ingredients.len)break
					var/what=input("What would you like taken out?")as null|anything in ingredients
					if(!what)break
					taken+="[what] "
					for(var/i in 1 to 4)
						ingredients-=what
					for(var/i in ingredients)
						src<<i
					if(alert("I have taken the [what] out. Will that be all sir, or would you like something else to be taken out?","Chef","That's Enough","I want something else out")=="I want something else out")
						continue
					else
						taken+="in it."
						break
				src<<"Of course sir, here is your [foodchoice] [taken ? "without any [taken]" : null]"

			else
				src<<"Alright then, here is your [foodchoice], enjoy!"